#include <qslider.h>
#include <qspinbox.h>
#include <qcombobox.h>
#include <qfile.h>
#include <qdir.h>
#include <qdatetime.h>

#include "datetime.h"

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>

datetime::datetime(QWidget *parent, const char *name):
    datetimeBase(parent, name)
{
    QDate date = QDate::currentDate();
    QTime time = QTime::currentTime();
    h_box->setValue(time.hour());
    m_box->setValue(time.minute());
    d_box->setValue(date.day());
    mn_box->setCurrentItem(date.month()-1);
    y_box->setValue(date.year());
}

void datetime::apply_button()
{
    QString data="/bin/date --set=\""+h_box->text()+":"+m_box->text()+" "+d_box->text()+"-"+mn_box->currentText()+"-"+y_box->text()+"\"";
    system( "/usr/X11R6/bin/xset s off" );
    system( "/usr/X11R6/bin/xset dpms 0 0 0" );
    system( "/usr/X11R6/bin/xset -dpms" );
    system( data );
    system( "/sbin/hwclock --systohc" );
    system( "/usr/X11R6/bin/xset s reset" );
    system( "killall -SIGUSR1 openbox" );
    system( "/usr/X11R6/bin/xrefresh" );
    QFile v(QDir::homeDirPath() + "/Choices/common/screenoff");
    if (v.exists()) {
	v.open(IO_ReadOnly);
	QString l = "";
	v.readLine(l, 5);
	v.close();
	int i = l.toInt();
	system("xset s " + l);
    }
    QFile v1(QDir::homeDirPath() + "/Choices/common/suspend");
    if (v1.exists()) {
	v1.open(IO_ReadOnly);
	QString l = "";
	v1.readLine(l, 5);
	v1.close();
	int i = l.toInt();
	system("xset dpms 0 0 " + l);
    }
    system( "/usr/X11R6/bin/xset +dpms" );
}
